{============================================================================}
{==                                                                        ==}
{==                  CHEAT VIEWER DATAFILE CODER Version 1.0               ==}
{==                    Copyright (C) 1996 By The GodFather                 ==}
{==                                                                        ==}
{============================================================================}

{$M, 8192, 0, 655355}

USES GUtils;

CONST
  JunkDta    = 'GF''s CHEAT VIEWER DATAFILE';
  HeaderSize = 31;

TYPE
  PArray = ^TArray;
  TArray = ARRAY[1..32000] OF Word;

  THeader = RECORD
    Junk    : ARRAY[1..26] OF Char;
    ID      : Byte;
    NDXSize : LongInt;
  END;

  NDXRec = RECORD
    Name   : STRING[60];
    Offset : LongInt;
    Lines  : Word;
  END;


PROCEDURE CreateTextIndex;
VAR Source,Index:Text; Line:STRING; Buf:Pointer;
    Current:Integer; FP:LongInt;

PROCEDURE Read_Line;
BEGIN
  ReadLn(Source,Line);
  Inc(Current); Inc(FP, Length(Line)); Inc(FP, 2);
END;

BEGIN
  Write('Creating text index.....');
  GetMem(Buf,65000);
  Assign(Source,'GCHEAT.TXT'); Reset  (Source);
  IF IOResult <> 0 THEN BEGIN
                          Writeln;
                          Writeln('Error can''t find GCHEAT.TXT');
                          Halt;
                        END;
  Assign(Index ,'GCHEAT.I_T'); Rewrite(Index);
  SetTextBuf(Index,Buf^,65000);

  FP := 0;
  REPEAT
    Current:= 1;   Write(Index, PadLeft(IntToStr(FP),9,' '));
    Read_Line;     Write(Index, PadLeft(Line,60,' '));
    Read_Line;
    REPEAT
      FillChar(Line,SizeOf(Line),0);
      Read_Line;
    UNTIL ((Line[1] = '') OR (Eof(Source)));
    Dec(Current);
    Writeln(Index,IntToStr(Current));
  UNTIL Eof(Source);
  Close(Source);
  Close(Index);
  FreeMem(Buf,65000);
  Writeln('done');
END;


PROCEDURE CreateBinIndex;
VAR NDX:NDXRec; TxtNDX:Text; Dest:FILE; W:Word;

  PROCEDURE Read_Line;
  VAR SOffset:STRING[9]; SName:STRING[60]; SLines:STRING[10]; I:Byte;
  BEGIN
    Read(TxtNDX,SOffset);  Read(TxtNDX,SName);  Readln(TxtNDX,SLines);
    NDX.Name := StripBoth(SName,' ');
    FOR I := 0 TO 60-1 DO
      NDX.Name[I+1] := Chr((Ord(NDX.Name[I+1]) XOR Ord(NDX.Name[I])) XOR $76);
    NDX.Offset := StrToInt(StripRight(SOffset,' '));
    NDX.Lines := StrToInt(SLines);
  END;

BEGIN
  Write('Converting text index.....');

  Assign(TxtNDX,'GCHEAT.I_T'); Reset(TxtNDX);
  Assign(Dest  ,'GCHEAT.NDX'); ReWrite(Dest,1);

  Read_Line;
  REPEAT
    Read_Line;
    BlockWrite(Dest,NDX,SizeOf(NDX),W);
  UNTIL Eof(TxtNDX);
  Close(TxtNDX);
  Close(Dest);
  Writeln('done');
END;


PROCEDURE CreateHeader;
VAR DataFile,Index:FILE; Header:THeader; W,R:Word; Buf:PArray;
BEGIN
  Write('Creating header.....');
  Header.Junk := JunkDta;
  Header.ID := $1A;
  Header.NDXSize := FSize('GCHEAT.NDX');
  Assign(DataFile,'GCHEAT.DAT'); Rewrite(DataFile,1);
  Assign(Index,'GCHEAT.NDX'); Reset(Index,1);
  BlockWrite(DataFile,Header,31,W);
  New(Buf);
  REPEAT
    BlockRead(Index,Buf^,SizeOf(Buf^),R);
    BlockWrite(DataFile,Buf^,R,W);
  UNTIL (R = 0) OR (W <> R);
  Close(Index);
  Close(DataFile);
  Dispose(Buf);
  DeleteFile('GCHEAT.I_T');
  DeleteFile('GCHEAT.NDX');
  Writeln('done');
END;

PROCEDURE AddCheatData;
VAR Source,Dest:Text; S:STRING; I:Byte; Buf:PArray;
BEGIN
  Write('Adding cheat data.....');
  New(Buf);
  Assign(Source,'GCHEAT.TXT'); Reset(Source);
  Assign(Dest  ,'GCHEAT.DAT'); Append(Dest);
  SetTextBuf(Dest,Buf^,SizeOf(Buf^));

  REPEAT
    ReadLn(Source,S);

    IF Length(S) <> 0 THEN
      FOR I := 0 TO Length(S)-1 DO
        S[I+1] := Chr(Ord(S[I+1]) XOR Ord(S[I]));

    Write(Dest,S+#0#255);
  UNTIL Eof(Source);
  Close(Source);
  Close(Dest);
  Dispose(Buf);
  Writeln('done');
END;


BEGIN
  Writeln('CHEAT VIEWER DATAFILE CODER by The GodFather');
  Writeln;

  CreateTextIndex;
  CreateBinIndex;
  CreateHeader;
  AddCheatData;

  Writeln;
  Writeln('Done.');
END.
